clc
clear all
close all
cvx_solver mosek
N=10;
epsilon_0=5;
pno = sqrt(10.^(-8));
theta_degree = -90:90;
theta_s = theta_degree*pi/180;
theta = [-45, 45,20,-20]*pi/180;
     n = 0:(N-1);
a_b = exp(1i * pi * n * sin(0)).';

NUM=100;
for OUTITER = 1:NUM

R_v=1:1:6; % varing R_b
for n_b=1:length(R_v)
    R_b=2^R_v( n_b)-1;

%statistical 

%Omega_w: The (l,m)th element of any spatial correlation matrix Omega_w in the system is generated based on eq. (2.23) in the following paper 
% E. Björnson, J. Hoydis, and L. Sanguinetti, "Massive MIMO networks:Spectral, energy, and hardware efficiency,” Found. Trends Signal Process., vol. 11, nos. 3–4, pp. 154–655, 2017.
lamida=3*10^8/(450*10^6);%wavelength 450M
d_h=lamida/2;
for l=1:1:N
    for m=1:1:N
        fun=@(x,y) exp(2.*pi.*j.*d_h.*(l-m).*sin(x)).*1./(2.*pi).*1./(sqrt(2.*pi).*pi./18).*exp(-y.^(2)/(pi./18.*pi./18.*2)) ;
        ymax=@(x) x+pi;
        ymin=@(x) x-pi;
        Omega_w(l,m)=sqrt(integral2(fun,-inf,inf,ymin,ymax)); 
    end
end


% channel initialization


G_NLoS = 1/sqrt(2)*(normrnd(0,1,N,1)+1i*normrnd(0,1,N,1));
h_b = sqrt(0.001*(abs(50))^(-2.5))*G_NLoS.*a_b;
h_b = h_b/pno;



M = length(theta);
P_a=5;
%P_amax=10;
%P_amin=1;
u_r_t = 1/sqrt(2)*(normrnd(0,1,N,1)+1i*normrnd(0,1,N,1));
for i = 1:N
	u_t1(i) = sqrt(0.5)*u_r_t(i)/abs(u_r_t(i));
end
u_r_r = 1/sqrt(2)*(normrnd(0,1,N,1)+1i*normrnd(0,1,N,1));
for i = 1:N
	u_r1(i) = sqrt(0.5)*u_r_r(i)/abs(u_r_r(i));
end

w_l=sqrt(1)*u_t1.';
w_l_ai =sqrt(1)* u_r1.';


   for i=1:181
if (abs(i-45)<=5)||(abs(i-70)<=5)||(abs(i-135)<=5)||(abs(i-110)<=5)
    p_wanted(i)=1;
else
    p_wanted(i)=0;
end
end

ns=1;ro1 = 0.1;
ro2 = 0.1;
 while(1)
cvx_begin sdp
            variables yita_1 yita_0 lamda pn_1 pn_2
            variable W_1(N,N) complex semidefinite            
            variable T_bar(N,N) complex semidefinite
            variable W_ai(N,N) complex semidefinite

 f=0;
             for i = 1:length(theta_s)
     n = 0:(N-1);
a = exp(1i * pi * n * sin(theta_s(i))).';
 f=f+square_pos(abs(yita_1*p_wanted(i)-a' * (W_1+T_bar+W_ai)* a));
             end

corr = 0;
             for k = 1:M
    for p = k+1:M
        a_k =  exp(1i * pi * n * sin(theta(k))).';
        a_p =  exp(1i * pi * n * sin(theta(p))).';
        corr = corr + square_pos(abs(a_k' * (W_1+T_bar+W_ai)* a_p));
    end
             end
F=1/length(theta_s)*f+2/(M*M-M)*corr; 



 

            minimize(F+ro1*pn_1+ro2*pn_2)
            subject to
real(trace(   Omega_w*(W_ai+T_bar)/P_a))>=4*real(trace(   Omega_w*(W_1)));

h_b'*W_1*h_b >=R_b*(1+h_b'*(W_ai+T_bar)*h_b );
 trace(W_ai+T_bar)==P_a;  trace(T_bar+W_ai+W_1)<=10;

 W_1 >= 0;
  T_bar>= 0;
W_ai>= 0;


real(trace(W_1'*(eye(N)-w_l*w_l'))) <= pn_1;
 real(trace(W_ai'*(eye(N)-w_l_ai*w_l_ai'))) <= pn_2;
  pn_1 >= 0;
  pn_2 >= 0;
 cvx_end


 Loss(n_b,ns,OUTITER)=F;
 U_1 =W_1;
	[V_1 D_1] = eigs(U_1); 
  	D1= diag(D_1);
	[a1 b1] = max(D1);
	w_l = V_1(:,b1);
    
    U_2 = W_ai;
	[V_2 D_2] = eigs(U_2);
  	D2= diag(D_2);
	[a2 b2] = max(D2);
	w_l_ai = V_2(:,b2);
if cvx_optval==-Inf
	break;
 end 

 if(pn_1>=0.0001)
        ro1 = ro1*1.01;
 end

 if(pn_2>=0.0001)
        ro2 = ro2*1.01;
 end



     if(ns>2)
       if(max([pn_1,pn_2])<=0.0001)&&(abs(Loss(n_b,ns,OUTITER)-Loss(n_b,ns-1,OUTITER))<=0.0001)
             Loss_converged(n_b,OUTITER) = Loss(n_b,ns,OUTITER);
         break;
        end
    end
ns = ns + 1;



 end

end

end


average_1=mean( Loss_converged,2);



 for i = 1:length(R_v)
   r1(i)=average_1(i,1);
end


i = 1:length(R_v);
plot(i,  r1, '-c', LineWidth=1.5);