clc
clear all
close all
cvx_solver mosek
N=10;
epsilon_0=5;
pno = sqrt(10.^(-8));
theta_degree = -90:90;
theta_s = theta_degree*pi/180;
theta = [-45, 45,20,-20]*pi/180;
     n = 0:(N-1);
a_b = exp(1i * pi * n * sin(0)).';


% channel initialization

G_NLoS = 1/sqrt(2)*(normrnd(0,1,N,1)+1i*normrnd(0,1,N,1));
h_b = sqrt(0.001*(abs(50))^(-2.5))*G_NLoS.*a_b;
h_b = h_b/pno;




M = length(theta);
h_w_bar=sqrt(0.001*(abs(50))^(-2.5))/pno*1/sqrt(2)*(normrnd(0,1,N,1)+1i*normrnd(0,1,N,1));%.*a_w
epsilon=0.1; 
P_a=5;
P_amax=10;
P_amin=1;
u_r_t = 1/sqrt(2)*(normrnd(0,1,N,1)+1i*normrnd(0,1,N,1));
for i = 1:N
	u_t1(i) = sqrt(0.5)*u_r_t(i)/abs(u_r_t(i));
end
u_r_r = 1/sqrt(2)*(normrnd(0,1,N,1)+1i*normrnd(0,1,N,1));
for i = 1:N
	u_r1(i) = sqrt(0.5)*u_r_r(i)/abs(u_r_r(i));
end

w_l=sqrt(1)*u_t1.';
w_l_ai =sqrt(1)* u_r1.';

mu=0.1;%bounded
epsilon_w=mu*sqrt(h_w_bar'*h_w_bar);
   for i=1:181
if (abs(i-45)<=5)||(abs(i-70)<=5)||(abs(i-135)<=5)||(abs(i-110)<=5)
    p_wanted(i)=1;
else
    p_wanted(i)=0;
end
end

ns=1;ro1 = 0.1;
ro2 = 0.1;
 while(1)
cvx_begin sdp
            variables yita_1 yita_0 lamda pn_1 pn_2
            variable W_1(N,N) complex semidefinite            
            variable T_bar(N,N) complex semidefinite
            variable W_ai(N,N) complex semidefinite

 f=0;
             for i = 1:length(theta_s)
     n = 0:(N-1);
a = exp(1i * pi * n * sin(theta_s(i))).';
 f=f+square_pos(abs(yita_1*p_wanted(i)-a' * (W_1+T_bar+W_ai)* a));
             end

corr = 0;
             for k = 1:M
    for p = k+1:M
        a_k =  exp(1i * pi * n * sin(theta(k))).';
        a_p =  exp(1i * pi * n * sin(theta(p))).';
        corr = corr + square_pos(abs(a_k' * (W_1+T_bar+W_ai)* a_p));
    end
             end
F=1/length(theta_s)*f+2/(M*M-M)*corr; 


            minimize(F+ro1*pn_1+ro2*pn_2)
            subject to
 lamda>=0;
 [lamda*eye(N)-(W_1-epsilon*(P_amax-P_amin)*(T_bar+W_ai)/P_a),-(W_1-epsilon*(P_amax-P_amin)*(T_bar+W_ai)/P_a)*h_w_bar; 
-h_w_bar'*(W_1-epsilon*(P_amax-P_amin)*(T_bar+W_ai)/P_a), -lamda*square_pos(epsilon_w)-h_w_bar'*(W_1-epsilon*(P_amax-P_amin)*(T_bar+W_ai)/P_a)*h_w_bar ]>=0;

 h_b'* W_ai*h_b >=h_b'*W_1*h_b;
 h_b'*W_1*h_b >=31*(1+h_b'*(T_bar)*h_b ) %if the ideal scenario is considered, remove h_b'*(T_bar)*h_b, and the inequality is changed to h_b'*W_1*h_b >=31*(1); if the proposed DFAN signal scheme scenario is considered, just refer to "fig5_bounded"
 trace(W_ai+T_bar)==P_a;  trace(T_bar+W_ai+W_1)<=10; 
 W_1 >= 0;
  T_bar>= 0;
W_ai>= 0;

real(trace(W_1'*(eye(N)-w_l*w_l'))) <= pn_1;
 real(trace(W_ai'*(eye(N)-w_l_ai*w_l_ai'))) <= pn_2;
  pn_1 >= 0;
  pn_2 >= 0;
 cvx_end


 Loss(ns)=F;
 U_1 =W_1;
	[V_1 D_1] = eigs(U_1); 
  	D1= diag(D_1);
	[a1 b1] = max(D1);
	w_l = V_1(:,b1);
    
    U_2 = W_ai;
	[V_2 D_2] = eigs(U_2);
  	D2= diag(D_2);
	[a2 b2] = max(D2);
	w_l_ai = V_2(:,b2);
if cvx_optval==-Inf
	break;
 end 

 if(pn_1>=0.0001)
        ro1 = ro1*1.01;
 end

 if(pn_2>=0.0001)
        ro2 = ro2*1.01;
 end



     if(ns>2)
       if(max([pn_1,pn_2])<=0.0001)&&(abs(Loss(ns)-Loss(ns-1))<=0.0001)
         break;
        end
    end
ns = ns + 1;



end




 for i = 1:length(theta_s)
    t = theta_s(i);
    n = 0:(N-1);
a = exp(1i * pi * n * sin(t)).';
    pattern_total(i) = real(a'*(W_1+T_bar+W_ai)*a);%Joint information and sensing signal beampattern
    pattern_signal(i) = real(a'*(W_1)*a);%Information signal beampattern
   pattern_only_sensing(i) = real(a'*(W_ai+T_bar)*a);%Sensing signal beampattern
end


subplot(2,1,1);
plot(theta_degree, yita_1*p_wanted, '-c', LineWidth=1.5);hold on;
plot(theta_degree, pattern_total, '-y', LineWidth=1.5);hold on;
plot(theta_degree, pattern_signal, '-b', LineWidth=1.5);hold on;
plot(theta_degree, pattern_only_sensing, '-g', LineWidth=1.5);
xlim([-90,90]);
xlabel("Azimuth Angle (degree)"); ylabel("Beampattern");


subplot(2,1,2);
x=1:1:ns;
plot(x,Loss, '-c', LineWidth=1.5)